﻿//	『昼夜逆転』工作室	http://jsdiy.web.fc2.com
//
//	FT232RLモジュール 7セグ制御 サンプルアプリ
//	「セグメントアタック」
//
//	2011/11/10	v1.00	初版

using System;
using FT232_7Seg4Lib;

namespace ft232r7seg4satk
{
	class Program
	{
		private static SegCtrl segled;

		static void Main(string[] args)
		{
			PortMgr pm = new PortMgr();
			
			//ブレッドボードバージョンでのピンアサイン（白黒の回路図）
			//SRegPin.P1～P8とSegLedPin.A～DPの対応はデフォルト値の通りなのでSetSRegPort()は省略
			pm.SetSRegCtrl(FtPin.D0, FtPin.D4, FtPin.D2);
			pm.SetSegLedDigit(FtPin.D6, FtPin.D5, FtPin.D7, FtPin.D1);
			
			/*	基板バージョンでのピンアサイン（カラーの配線図）
			pm.SetSRegPort(SRegPin.P8, SegLedPin.A);
			pm.SetSRegPort(SRegPin.P1, SegLedPin.B);
			pm.SetSRegPort(SRegPin.P3, SegLedPin.C);
			pm.SetSRegPort(SRegPin.P5, SegLedPin.D);
			pm.SetSRegPort(SRegPin.P6, SegLedPin.E);
			pm.SetSRegPort(SRegPin.P7, SegLedPin.F);
			pm.SetSRegPort(SRegPin.P2, SegLedPin.G);
			pm.SetSRegPort(SRegPin.P4, SegLedPin.DP);
			pm.SetSRegCtrl(FtPin.D0, FtPin.D4, FtPin.D2);
			pm.SetSegLedDigit(FtPin.D6, FtPin.D5, FtPin.D7, FtPin.D1);
			*/
			segled = new SegCtrl(pm);
			
			//7セグ制御開始
			if (!segled.Start(true))
			{
				Console.WriteLine("FT232 ready...");
				if (!segled.Start()) AppClose(segled.EMessage, segled.ECode);
			}
			
			//説明表示
			Console.WriteLine("- Segment Atack! -  jsdiy/(C)2011~ http://jsdiy.web.fc2.com");
			Console.WriteLine();
			Console.WriteLine("【ゲーム内容】" + Environment.NewLine +
				"ワンキー・アクションゲームです。" + Environment.NewLine +
				"壊れた数字にセグメント（数字の'かけら'）を投げつけて倒します。" + Environment.NewLine +
				"1桁目（左端）が投げる'かけら'、4桁目（右端）が壊れている数字です。");
			Console.WriteLine();
			Console.WriteLine("【ゲームのルール】" + Environment.NewLine +
				"プレイヤー（左端）が投げる'かけら'がランダムで表示されます。" + Environment.NewLine +
				"投げた'かけら'が壊れた数字にはまり、数字が完成したら1個クリア（倒した）。" + Environment.NewLine +
				"完成すると目印に「.」が点灯し、数字ごと消え、次の壊れた数字が現れます。" + Environment.NewLine +
				"既に数字の一部があるところへ投げると、その位置の'かけら'は消えます。" + Environment.NewLine +
				"一定時間が経過するとごとに壊れた数字はプレイヤー側へ移動してきます。" + Environment.NewLine +
				"プレイヤーに重なったらゲームオーバー。" + Environment.NewLine +
				"[Space]キーを押してスコア画面→ハイスコア画面→タイトル画面へと進みます。");
			Console.WriteLine();
			Console.WriteLine("【キー操作】" + Environment.NewLine +
				"[Space]キーでゲーム開始、'かけら'を発射、次の画面へ進む。" + Environment.NewLine +
				"タイトル画面のとき [Shift]+[Space]キーでハイスコア表示。" + Environment.NewLine +
				"アプリ実行中はいつでも [Esc]キーでアプリ終了。");

			//ゲーム起動
			Game game = new Game(segled);
			game.Start();

			//アプリ終了
			if (segled.IsError)
				AppClose(segled.EMessage, segled.ECode);
			else
				AppClose();
		}

		//アプリ終了
		private static void AppClose() { AppClose(null, 0); }
		private static void AppClose(string mes, int exitCode)
		{
			//7セグ オブジェクト破棄
			if (segled != null) segled.Dispose();

			//終了メッセージを表示する
			if (mes != null)
			{
				Console.WriteLine(mes + Environment.NewLine);
				Console.WriteLine("Press any key.");
				Console.ReadKey();
			}

			Environment.Exit(exitCode);
		}
		
	}	//<- end of class
	
}	//<- end of namespace
